## libdrumstick 1.1.3

=== CMakeLists.txt ===
# MIDI C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

project(DRUMSTICK)

set(CMAKE_COLOR_MAKEFILE ON)
#set(CMAKE_VERBOSE_MAKEFILE ON)
#set(CMAKE_CXX_VISIBILITY_PRESET hidden)
#set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# Additional CMake modules for 3rd party library checks reside here
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_admin")

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

include(GNUInstallDirs)

# DRUMSTICK version string
set(VERSION_MAJOR "1")
set(VERSION_MINOR "1")
set(VERSION_PATCH "3")
set(VERSION_SUFFIX "")
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX})
add_definitions(-DVERSION=${VERSION})

message(STATUS "drumstick ${VERSION} prefix ${CMAKE_INSTALL_PREFIX}")

set(_DBUS_INIT OFF)

# User options
option(STATIC_DRUMSTICK "Build static libraries instead of dynamic" OFF)
option(USE_DBUS "Include DBus support (required for RealtimeKit)" ${_DBUS_INIT})

message(STATUS "Build configuration: ${CMAKE_BUILD_TYPE}")

if(STATIC_DRUMSTICK)
    set(BUILD_SHARED_LIBS OFF)
    add_definitions(-DDRUMSTICK_STATIC)
    message(STATUS "Building static libraries")
else()
    set(BUILD_SHARED_LIBS ON)
    message(STATUS "Building dynamic libraries")
endif()

find_package(Qt5Core REQUIRED)
message(STATUS "Found Qt5 version = ${Qt5Core_VERSION_STRING}")

if(USE_DBUS)
    find_package(Qt5DBus REQUIRED)
    add_definitions(-DRTKIT_SUPPORT)
endif()

if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    find_package(PkgConfig REQUIRED)
    if(PKG_CONFIG_FOUND)
        message(STATUS "Program pkg-config found (${PKG_CONFIG_EXECUTABLE})")
    else()
        message(FATAL_ERROR "Program pkg-config not found")
    endif()
endif()

if(${CMAKE_SYSTEM} MATCHES "Linux")
    pkg_check_modules(ALSA alsa>=1.0.0)
    if(ALSA_FOUND)
        set(ALSA_LIBS ${ALSA_LIBRARIES})
        list(APPEND ALSA_LIB_DIR ${ALSA_LIBRARY_DIRS} ${ALSA_LIBDIR})
        list(APPEND ALSA_INC_DIR ${ALSA_INCLUDE_DIRS} ${ALSA_INCLUDEDIR})
    else()
        message(STATUS "Warning: ALSA library not found.")
    endif()
endif()

if(PKG_CONFIG_FOUND)
    pkg_check_modules(PULSE libpulse-simple)
    if(NOT PULSE_FOUND)
        message(STATUS "Warning: PulseAudio library not found.")
    endif()
endif()

if(${CMAKE_SYSTEM} MATCHES "Darwin")
    find_package(Qt5Concurrent REQUIRED)
endif()

link_directories(${DRUMSTICK_BINARY_DIR}/lib)

add_subdirectory(library)
add_subdirectory(utils)
add_subdirectory(icons)

include(CTest)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

if(${CMAKE_SYSTEM} MATCHES "Linux")
    find_package(Doxygen)
    if(DOXYGEN_FOUND)
        configure_file(
            "${CMAKE_SOURCE_DIR}/Doxyfile.in"
            "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
            IMMEDIATE @ONLY)
        add_custom_target(doxygen
            ${DOXYGEN} Doxyfile
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
    add_subdirectory(doc)
    configure_file(drumstick-alsa.pc.in drumstick-alsa.pc IMMEDIATE @ONLY)
    configure_file(drumstick.spec.in drumstick.spec IMMEDIATE @ONLY)
    install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/drumstick-alsa.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    # XML mime types
    set( SHARED_MIME_INFO_MINIMUM_VERSION "0.30" )
    set( XDG_MIME_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/mime/packages" )
    find_package( SharedMimeInfo )
    if( SHARED_MIME_INFO_FOUND )
        install( FILES drumstick.xml DESTINATION ${XDG_MIME_INSTALL_DIR} )
        update_xdg_mimetypes( ${XDG_MIME_INSTALL_DIR} )
    endif()
endif()

configure_file(drumstick-file.pc.in drumstick-file.pc IMMEDIATE @ONLY)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/drumstick-file.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )

configure_file(drumstick-rt.pc.in drumstick-rt.pc IMMEDIATE @ONLY)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/drumstick-rt.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )

# uninstall custom target
configure_file(
    "${CMAKE_SOURCE_DIR}/cmake_admin/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target( uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if(UNIX)
    # tarball target
    add_custom_target( tarball
        COMMAND mkdir -p drumstick-${VERSION}
        COMMAND cp -r cmake_admin drumstick-${VERSION}
        COMMAND cp -r library drumstick-${VERSION}
        COMMAND cp -r utils drumstick-${VERSION}
        COMMAND cp -r doc drumstick-${VERSION}
        COMMAND cp -r icons drumstick-${VERSION}
        COMMAND cp -r tests drumstick-${VERSION}
        COMMAND cp CMakeLists.txt AUTHORS COPYING ChangeLog INSTALL NEWS README TODO drumstick*.in drumstick.pro drumstick.xml configure* Doxyfile.in chkcoverage global.pri drumstick-${VERSION}
        COMMAND tar -cj --exclude=.[a-z]* -f drumstick-${VERSION}.tar.bz2 drumstick-${VERSION}
        COMMAND tar -cz --exclude=.[a-z]* -f drumstick-${VERSION}.tar.gz  drumstick-${VERSION}
        COMMAND zip -qr drumstick-${VERSION}.zip drumstick-${VERSION} -x '.[a-z]*'
        COMMAND rm -rf drumstick-${VERSION}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
endif()

=== doc/CMakeLists.txt ===
# MIDI Sequencer C++ Library 
# Copyright (C) 2008-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

FIND_PROGRAM(XSLTPROC_EXECUTABLE xsltproc)
IF(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    CONFIGURE_FILE(drumstick-drumgrid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpmid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpove.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpove.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpwrk.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-metronome.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-playsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-guiplayer.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-sysinfo.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-vpiano.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml IMMEDIATE @ONLY)
    INCLUDE(CreateManpages)
    CREATE_MANPAGES ( 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpove.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml 
    )
ELSE(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "Warning: XSLTPROC NOT Found. Man pages won't be installed")
ENDIF(XSLTPROC_EXECUTABLE)

=== icons/CMakeLists.txt ===
INSTALL(FILES drumstick_16.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps"
    RENAME drumstick.png)

INSTALL(FILES drumstick_32.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps"
    RENAME drumstick.png)

INSTALL(FILES drumstick_48.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps"
    RENAME drumstick.png)

INSTALL(FILES drumstick_64.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps"
    RENAME drumstick.png)

INSTALL(FILES drumstick.svgz
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps")

=== library/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

if(ALSA_FOUND)
    add_subdirectory(alsa)
endif()
add_subdirectory(file)
add_subdirectory(rt)
add_subdirectory(rt-backends)

=== tests/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

find_package(Qt5Test REQUIRED)
set (CMAKE_AUTOMOC ON)
enable_testing()

if (ALSA_FOUND)
    add_subdirectory(alsaTest1)
    add_subdirectory(alsaTest2)
endif()

add_subdirectory(fileTest)
add_subdirectory(rtTest)

=== utils/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

#include_directories(
#    ${CMAKE_CURRENT_SOURCE_DIR}
#    ${CMAKE_CURRENT_BINARY_DIR}
#    ${CMAKE_CURRENT_SOURCE_DIR}/common
#)

add_subdirectory(dumpsmf)
add_subdirectory(dumpwrk)
add_subdirectory(dumpove)
add_subdirectory(vpiano)

if(ALSA_FOUND)
    add_subdirectory(dumpmid)
    add_subdirectory(playsmf)
    add_subdirectory(guiplayer)
    add_subdirectory(sysinfo)
    add_subdirectory(metronome)
    add_subdirectory(drumgrid)
endif()

=== library/alsa/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)
#include_directories(${ALSA_INC_DIR})
link_directories(${ALSA_LIB_DIR})

set(drumstick-alsa_QTOBJ_SRCS
    ../include/drumstick/alsaclient.h
    ../include/drumstick/alsaevent.h
    ../include/drumstick/alsaport.h
    ../include/drumstick/alsaqueue.h
    ../include/drumstick/alsatimer.h
    ../include/drumstick/playthread.h
)

set(drumstick-alsa_HEADERS
    ../include/drumstick/alsaclient.h
    ../include/drumstick/alsaevent.h
    ../include/drumstick/alsaport.h
    ../include/drumstick/alsaqueue.h
    ../include/drumstick/alsatimer.h
    ../include/drumstick/drumstickcommon.h
    ../include/drumstick/playthread.h
    ../include/drumstick/subscription.h
)

SET(drumstick-alsa_SRCS
    alsaclient.cpp
    alsaevent.cpp
    alsaport.cpp
    alsaqueue.cpp
    alsatimer.cpp
    playthread.cpp
    subscription.cpp
)


qt5_wrap_cpp(drumstick-alsa_MOC_SRCS ${drumstick-alsa_QTOBJ_SRCS})

add_library(drumstick-alsa
    ${drumstick-alsa_MOC_SRCS}
    ${drumstick-alsa_SRCS}
    ${drumstick-alsa_HEADERS}
)

add_library(Drumstick::ALSA ALIAS drumstick-alsa)

target_include_directories(drumstick-alsa
    PUBLIC  $<BUILD_INTERFACE:${DRUMSTICK_SOURCE_DIR}/library/include>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE}>
    PRIVATE ${ALSA_INC_DIR}
)

target_link_libraries(drumstick-alsa
    ${ALSA_LIBS}
    Qt5::Core
)

if(USE_DBUS)
    target_link_libraries(drumstick-alsa
        Qt5::DBus
    )
endif()

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-alsa PROPERTIES
         STATIC_LIB "libdrumstick-alsa")
else()
    set_target_properties(drumstick-alsa PROPERTIES
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        SOVERSION ${VERSION_MAJOR}
    )
endif()

install(TARGETS drumstick-alsa EXPORT drumstick-alsa-config
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${drumstick-alsa_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)
install(FILES ../include/drumstick.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT drumstick-alsa-config
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/drumstick/cmake)

export(TARGETS drumstick-alsa FILE drumstick-alsa-config.cmake)

=== library/file/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)
if (APPLE)
    set(CMAKE_MACOSX_RPATH 1)
    set(MACOSX_FRAMEWORK_IDENTIFIER “net.sourceforge”)
    set(MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
    set(MACOSX_FRAMEWORK_BUNDLE_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
endif()

set(drumstick-file_QTOBJ_SRCS
    ../include/drumstick/qsmf.h
    ../include/drumstick/qwrk.h
    ../include/drumstick/qove.h
)

set(drumstick-file_HEADERS
    ../include/drumstick/macros.h
    ../include/drumstick/qsmf.h
    ../include/drumstick/qwrk.h
    ../include/drumstick/qove.h
)

set(drumstick-file_SRCS
    qsmf.cpp
    qwrk.cpp
    qove.cpp
)

qt5_wrap_cpp(drumstick-file_MOC_SRCS ${drumstick-file_QTOBJ_SRCS})

add_library(drumstick-file
    ${drumstick-file_MOC_SRCS}
    ${drumstick-file_SRCS} 
    ${drumstick-file_HEADERS} 
)

add_library(Drumstick::File ALIAS drumstick-file)

target_include_directories(drumstick-file PUBLIC
    $<BUILD_INTERFACE:${DRUMSTICK_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE}>
)

target_link_libraries(drumstick-file Qt5::Core)

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-file PROPERTIES
        STATIC_LIB "libdrumstick-file")
else()
    set_target_properties(drumstick-file PROPERTIES
        FRAMEWORK TRUE
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        SOVERSION ${VERSION_MAJOR})

endif()

install(TARGETS drumstick-file EXPORT drumstick-file-config
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-file_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-file-config
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/drumstick/cmake)

export(TARGETS drumstick-file FILE drumstick-file-config.cmake)

=== library/rt-backends/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

if(FALSE)
    add_subdirectory(dummy-in)
    add_subdirectory(dummy-out)
endif()

if(ALSA_FOUND)
    add_subdirectory(alsa-in)
    add_subdirectory(alsa-out)
endif()

if (PULSE_FOUND)
    add_subdirectory(eassynth)
endif()

find_package(Qt5Network)
if(Qt5Network_FOUND)
    add_subdirectory(net-in)
    add_subdirectory(net-out)
endif()

if(UNIX AND NOT APPLE)
    add_subdirectory(oss-in)
    add_subdirectory(oss-out)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_subdirectory(mac-in)
    add_subdirectory(mac-out)
    add_subdirectory(macsynth)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_subdirectory(win-in)
    add_subdirectory(win-out)
endif()

if (PKG_CONFIG_FOUND)
    pkg_check_modules(FLUIDSYNTH fluidsynth>=1.1.1 fluidsynth<=1.1.11)
    if(FLUIDSYNTH_FOUND)
        add_subdirectory(fluidsynth)
    endif()
endif()

=== library/rt/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)
if (APPLE)
    set(CMAKE_MACOSX_RPATH 1)
    set(MACOSX_FRAMEWORK_IDENTIFIER “net.sourceforge”)
    set(MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
    set(MACOSX_FRAMEWORK_BUNDLE_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
endif()

set(drumstick-rt_QOBJ_SRCS
    ../include/drumstick/rtmidiinput.h
    ../include/drumstick/rtmidioutput.h
)

set(drumstick-rt_HEADERS
    ../include/drumstick/macros.h
    ../include/drumstick/rtmidiinput.h
    ../include/drumstick/rtmidioutput.h
    ../include/drumstick/backendmanager.h
)

set(drumstick-rt_SRCS
    backendmanager.cpp
)
    
qt5_wrap_cpp(drumstick-rt_MOC_SRCS ${drumstick-rt_QOBJ_SRCS})

add_library(drumstick-rt
    ${drumstick-rt_MOC_SRCS}
    ${drumstick-rt_SRCS}
    ${drumstick-rt_HEADERS}
)

add_library(Drumstick::RT ALIAS drumstick-rt)

target_include_directories(drumstick-rt PUBLIC
    $<BUILD_INTERFACE:${DRUMSTICK_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE}>
)

target_compile_definitions(drumstick-rt
    PRIVATE LIBSUFFIX=${CMAKE_INSTALL_LIBDIR})

target_link_libraries(drumstick-rt Qt5::Core)

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-rt PROPERTIES
        STATIC_LIB "libdrumstick-rt")
    #
    #    target_compile_definitions(drumstick-rt DUMMY_BACKEND)
    #    target_link_libraries(drumstick-rt drumstick-rt-dummy-in)
    #    target_link_libraries(drumstick-rt drumstick-rt-dummy-out)
    #

    if(ALSA_FOUND)
        target_compile_definitions(drumstick-rt LINUX_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-alsa-in
            drumstick-rt-alsa-out
            drumstick-rt-eassynth
            drumstick-alsa)
    endif()

    if(UNIX AND NOT APPLE)
        target_compile_definitions(drumstick-rt OSS_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-oss-in
            drumstick-rt-oss-out)
    endif()


    if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        target_compile_definitions(drumstick-rt MAC_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-mac-in
            drumstick-rt-mac-out
            drumstick-rt-macsynth
            "-framework CoreMIDI -framework CoreFoundation")
    endif()


    if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
        target_compile_definitions(drumstick-rt WIN_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-win-in
            drumstick-rt-win-out
            winmm)
    endif()


    find_package(Qt5Network)
    if(Qt5Network_FOUND)
        target_compile_definitions(drumstick-rt NET_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-net-in
            drumstick-rt-net-out)
    endif()

    if(PKG_CONFIG_FOUND)
        pkg_check_modules(FLUIDSYNTH fluidsynth>=1.1.1)
        if(FLUIDSYNTH_FOUND)
            target_compile_definitions(drumstick-rt SYNTH_BACKEND)
            target_link_libraries(drumstick-rt drumstick-rt-synth)
        endif()
    endif()

else() # STATIC_DRUMSTICK

    set_target_properties(drumstick-rt PROPERTIES
        FRAMEWORK TRUE
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        SOVERSION ${VERSION_MAJOR})
endif()

install(TARGETS drumstick-rt EXPORT drumstick-rt-config
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-rt_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-rt-config
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/drumstick/cmake)

export(TARGETS drumstick-rt FILE drumstick-rt-config.cmake)

=== tests/alsaTest1/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

add_executable (alsaTest1 alsatest1.cpp)

target_link_libraries (alsaTest1
    drumstick-alsa
    Qt5::Core
    Qt5::Test
)

add_test (alsaTest1 ${PROJECT_BINARY_DIR}/bin/alsaTest1)

=== tests/alsaTest2/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

add_executable (alsaTest2 alsatest2.cpp)

target_link_libraries (alsaTest2
    drumstick-alsa
    Qt5::Core
    Qt5::Test
)

add_test (alsaTest2 ${PROJECT_BINARY_DIR}/bin/alsaTest2)

=== debian/changelog ===
libdrumstick (1.1.3-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 18 Jan 2021 23:26:13 -0500

libdrumstick (1.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Add libfluidsynth-dev to B-D.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 05 Sep 2019 21:14:40 +0200

libdrumstick (1.1.2-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/copyright: Add missing copyright holders. (Closes: #935387)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 22 Aug 2019 18:19:32 +0200

libdrumstick (1.1.2-1) experimental; urgency=medium

  * Team upload.

  [ Ross Gammon ]
  * New upstream release
  * Drop gcc6 patch, included in this upstream version
  * Refresh desktop patch, and drop parts applied upstream
  * Update copyright file and add myself
  * Desktop patch forwarded upstream
  * Desktop patch applied upstream

  [ Ondřej Nový ]
  * d/copyright: Change Format URL to correct one
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * d/watch: Use https protocol
  * Use debhelper-compat instead of debian/compat

  [ Sebastian Ramacher ]
  * debian/: Split shared library package to match SONAMEs and add package for
    realtime I/O backends.
  * debian/rules:
    - Use architecture.mk.
    - Remove obsolete dh_strip override.
    - Skip tests if /dev/snd/seq is not available.
  * debian/control:
    - Bump debhelper compat to 12.
    - Bump Standards-Version.
    - Add libpulse-dev to B-D (for eassynth).
  * debian/: Remove obsolete *.dirs.
  * debian/copyright: Update copyright years.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 18 Aug 2019 23:35:25 +0200

=== debian/control ===
Source: libdrumstick
Section: libs
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Arnout Engelen <arnouten@bzzt.net>,
 Ross Gammon <rosco2@ubuntu.com>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 docbook-xml,
 docbook-xsl,
 libasound2-dev,
 libfluidsynth-dev (>= 1.1.1),
 libpulse-dev,
 libqt5svg5-dev,
 qtbase5-dev,
 libx11-dev,
 pkg-config,
 xsltproc
Standards-Version: 4.4.0
Homepage: http://drumstick.sourceforge.net/
Vcs-Git: https://salsa.debian.org/multimedia-team/libdrumstick.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libdrumstick

Package: libdrumstick-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdrumstick-alsa1 (= ${binary:Version}),
 libdrumstick-file1 (= ${binary:Version}),
 libdrumstick-rt1 (= ${binary:Version}),
 ${misc:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (development files)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for OVE and WRK file
 processing are also included.
 .
 This package provides the development files.

Package: libdrumstick-alsa1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for OVE and WRK file
 processing are also included.
 .
 This package provides the shared library.

Package: libdrumstick-file1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: File format support library for drumstick (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for OVE and WRK file
 processing are also included.
 .
 This package contains the shared library for support of MIDI, Cakewalk and
 Overture file formats.

Package: libdrumstick-rt1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 libdrumstick-rt-backends (= ${binary:Version}),
 rtkit
Description: Realtime MIDI I/O with pluggable backends (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for OVE and WRK file
 processing are also included.
 .
 This package contains the shared library for realtime MIDI I/O with plugin
 support.

Package: libdrumstick-rt-backends
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Realtime MIDI I/O backends
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for OVE and WRK file
 processing are also included.
 .
 This package contains the bakcends for realtime MIDI I/O.

Package: drumstick-tools
Section: sound
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer (utilities)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for OVE and WRK file
 processing are also included.
 .
 This package provides utilities shipped with the library:
  - drumstick-buildsmf: Standard MIDI File creation from scratch.
  - drumstick-dumpgrid: Simple Qt drum sequencer.
  - drumstick-dumpmid: Write ALSA MIDI events to STDOUT.
  - drumstick-dumpsmf: Write MIDI events from a MIDI file to STDOUT.
  - drumstick-dumpwrk: Write MIDI events from a Cakewalk WRK file to STDOUT.
  - drumstick-guiplayer: Simple Qt MIDI file player.
  - drumstick-metronome: Headless MIDI metronome.
  - drumstick-playsmf: Headless MIDI file player.
  - drumstick-sysinfo: Display information about ALSA MIDI.
  - drumstick-timertest: Test performance of the ALSA timer.
  - drumstick-vpiano: Virtual Piano Keyboard GUI application.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

LDFLAGS+=-Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@ -S cmake

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
	if -f /dev/snd/deq ; then dh_auto_test ; fi

## libdrumstick 2.3.1

=== debian/changelog ===
libdrumstick (2.3.1-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 04 Oct 2021 23:53:38 -0400

libdrumstick (2.3.1-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream version 2.3.1
  * Bump Standards-Version to 4.6.0
  * Add libdrumstick-rt-backends to libdrumstick-dev Depends for cmake files

 -- Dennis Braun <d_braun@kabelmail.de>  Tue, 07 Sep 2021 22:03:03 +0200

libdrumstick (2.0.0-1) experimental; urgency=medium

  [ Olivier Humbert ]
  * Update copyright (http->https)
  * Update control (update re: provided binaries)
  * Update control (definition)

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1

  [ Dennis Braun ]
  * New upstream version 2.0.0
  * Update d/watch version to 4
  * Add me as uploader
  * Bump dh-compat to 13
  * Bump S-V to 4.5.1
  * Set RRR: no
  * Update B-Ds: Add doxygen, graphviz and qttools5-dev
  * Bump ABI version to libdrumstick-*2
  * d/copyright: Change main license to GPLv3, bump copyright year
  * Remove unnecessary d/docs file
  * Add drumstick-data, libdrumstick-plugins and libdrumstick-widgets2 packages
  * Update the install packages
  * Remove unnecessary build flags from d/rules

  [ Sebastian Ramacher ]
  * debian/control:
    - Remove ${shlibs:Depends} from libdrumstick-dev
    - Add ${shlib:Depends} to drumstick-tools

 -- Dennis Braun <d_braun@kabelmail.de>  Tue, 12 Jan 2021 21:42:42 +0100

=== debian/control ===
--- 
+++ 
@@ -7,33 +7,40 @@
  Alessio Treglia <alessio@debian.org>,
  Adrian Knoth <adi@drcomp.erfurt.thur.de>,
  Arnout Engelen <arnouten@bzzt.net>,
- Ross Gammon <rosco2@ubuntu.com>
+ Ross Gammon <rosco2@ubuntu.com>,
+ Dennis Braun <d_braun@kabelmail.de>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  docbook-xml,
  docbook-xsl,
+ doxygen,
+ graphviz,
  libasound2-dev,
  libfluidsynth-dev (>= 1.1.1),
  libpulse-dev,
  libqt5svg5-dev,
  qtbase5-dev,
+ qttools5-dev,
  libx11-dev,
  pkg-config,
  xsltproc
-Standards-Version: 4.4.0
+Standards-Version: 4.6.0
 Homepage: http://drumstick.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/multimedia-team/libdrumstick.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/libdrumstick
+Rules-Requires-Root: no
 
 Package: libdrumstick-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Depends:
- libdrumstick-alsa1 (= ${binary:Version}),
- libdrumstick-file1 (= ${binary:Version}),
- libdrumstick-rt1 (= ${binary:Version}),
+ libdrumstick-alsa2 (= ${binary:Version}),
+ libdrumstick-file2 (= ${binary:Version}),
+ libdrumstick-rt-backends (= ${binary:Version}),
+ libdrumstick-rt2 (= ${binary:Version}),
+ libdrumstick-widgets2 (= ${binary:Version}),
  ${misc:Depends}
 Description: Qt5/C++ wrapper for ALSA Sequencer (development files)
  This library is a C++ wrapper around the ALSA library sequencer interface,
@@ -43,7 +50,7 @@
  .
  This package provides the development files.
 
-Package: libdrumstick-alsa1
+Package: libdrumstick-alsa2
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -57,7 +64,7 @@
  .
  This package provides the shared library.
 
-Package: libdrumstick-file1
+Package: libdrumstick-file2
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -71,8 +78,22 @@
  .
  This package contains the shared library for support of MIDI, Cakewalk and
  Overture file formats.
+ 
+Package: libdrumstick-plugins
+Architecture: any
+Multi-Arch: same
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
+Description: Realtime MIDI I/O with pluggable backends (Qt designer plugins)
+ This library is a C++ wrapper around the ALSA library sequencer interface,
+ using Qt5 objects, idioms and style. ALSA sequencer provides software support
+ for MIDI technology on Linux. Complementary classes for OVE and WRK file
+ processing are also included.
+ .
+ This package contains the libdrumstick Qt designer plugins.
 
-Package: libdrumstick-rt1
+Package: libdrumstick-rt2
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -89,7 +110,7 @@
  .
  This package contains the shared library for realtime MIDI I/O with plugin
  support.
-
+ 
 Package: libdrumstick-rt-backends
 Architecture: any
 Multi-Arch: same
@@ -102,12 +123,42 @@
  for MIDI technology on Linux. Complementary classes for OVE and WRK file
  processing are also included.
  .
- This package contains the bakcends for realtime MIDI I/O.
+ This package contains the backends for realtime MIDI I/O.
+
+Package: libdrumstick-widgets2
+Architecture: any
+Multi-Arch: same
+Depends:
+ drumstick-data (= ${source:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends}
+Description: Qt5/C++ wrapper for ALSA Sequencer (widgets)
+ This library is a C++ wrapper around the ALSA library sequencer interface,
+ using Qt5 objects, idioms and style. ALSA sequencer provides software support
+ for MIDI technology on Linux. Complementary classes for OVE and WRK file
+ processing are also included.
+ .
+ This package contains the shared drumstick widgets library.
+ 
+Package: drumstick-data
+Architecture: all
+Multi-Arch: foreign
+Depends:
+ ${misc:Depends}
+Description: Qt5/C++ wrapper for ALSA Sequencer (data files)
+ This library is a C++ wrapper around the ALSA library sequencer interface,
+ using Qt5 objects, idioms and style. ALSA sequencer provides software support
+ for MIDI technology on Linux. Complementary classes for OVE and WRK file
+ processing are also included.
+ .
+ This package provides data files for drumstick-tools and libdrumstick-widgets2.
 
 Package: drumstick-tools
 Section: sound
 Architecture: any
 Depends:
+ drumstick-data (= ${source:Version}),
+ libdrumstick-plugins (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
 Description: Qt5/C++ wrapper for ALSA Sequencer (utilities)
@@ -117,14 +168,13 @@
  processing are also included.
  .
  This package provides utilities shipped with the library:
-  - drumstick-buildsmf: Standard MIDI File creation from scratch.
   - drumstick-dumpgrid: Simple Qt drum sequencer.
   - drumstick-dumpmid: Write ALSA MIDI events to STDOUT.
+  - drumstick-dumpove: A command line utility for decoding OVE (Overture) files.
   - drumstick-dumpsmf: Write MIDI events from a MIDI file to STDOUT.
   - drumstick-dumpwrk: Write MIDI events from a Cakewalk WRK file to STDOUT.
   - drumstick-guiplayer: Simple Qt MIDI file player.
   - drumstick-metronome: Headless MIDI metronome.
   - drumstick-playsmf: Headless MIDI file player.
   - drumstick-sysinfo: Display information about ALSA MIDI.
-  - drumstick-timertest: Test performance of the ALSA timer.
   - drumstick-vpiano: Virtual Piano Keyboard GUI application.

=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,10 @@
 
 include /usr/share/dpkg/architecture.mk
 
-LDFLAGS+=-Wl,--as-needed
 export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
 
 %:
-	dh $@ -S cmake
+	dh $@ -Scmake
 
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym
